# (Explorer Workshop)
# Copyright: 2024 Bradan Lane STUDIO
#
# Open Source License: MIT

'''
This Python program is a sample from the 'Python' workshop

Implementation Notes
--------------------
**Hardware:**
    * computer

**Software and Dependencies:**
    * Python 3.x
    * Thonny 4.x IDE

**Open Source Repository:**
    * GitLab: https://gitlab.com/bradanlane/exp_tutorial
    
'''

import json

class JSONScanner:
    def __init__(self, filename):
        self.__filename = filename
        self.__data = None
        with open(self.__filename, 'r') as f:
            # read the file contents and create a list of nested dictionaries and list data
            self.__data = json.load(f)

    def scan(self, key, value):
        result = {} # this is an empty dictionary
        '''
        a dictionary consists of key:value pairs
        eg: dict[key] = value
        '''
        # keywords is a list; the for look iterates the list, returning one element at a time
        # data is a dictionary; data[keyword] is a value
        for person in self.__data:
            if key in person:
                result[person[key]] = person[value]
        return result


scanner = JSONScanner('data/people.json')
result = scanner.scan('name', 'age')
print(result)   # results in a dictionary where the key is a person's name and the value is their age
